<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Filter order Page</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!--- DataTable-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- font awsome icon cdn -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.0/css/all.min.css">

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="User_list.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">AdminLTE 3</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Admin Pham Dac Thanh</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Danh sách page
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="User_list.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Demo Use list page</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="CRUD_user.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>CRUD user page</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="Filter_order.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Filter order page</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Filter order</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Filter order</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
        <div class="container">
          <div class="row form-group">
            <div class="col-sm-4">
              <div class="row">
                <div class="col-sm-4">
                  <label for="firstName">Order Status</label>
                </div>
                <div class="col-sm-8">
                  <select type="text" class="form-control" id="inp-order-status">
                    <option value="0">(all)</option>
                    <option value="open">open</option>
                    <option value="confirmed">confirmed</option>
                    <option value="cancel">cancel</option>
                  </select>
                </div>
              </div>
            </div>
            <div class="col-sm-4">
              <div class="row">
                <div class="col-sm-4">
                  <label for="LastName">Loại Pizza</label>
                </div>
                <div class="col-sm-8">
                  <select type="text" class="form-control" id="inp-loai-pizza">
                    <option value="0">(all)</option>
                    <option value="hawai">HAWAII</option>
                    <option value="bacon">BACON</option>
                    <option value="seafood">SEAFOOD</option>
                  </select>
                </div>
              </div>
            </div>
            <div class="col-sm-4 ">
              <div>
                <button class="btn btn-secondary btn-filter-order">Filter data</button>
              </div>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>order ID</th>
              <th>Kích Cỡ Combo</th>
              <th>loại Pizza</th>
              <th>Nước Uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>trạng thái</th>
              <th>Detail</th>
            </tr>
        </table>
      </div>
      
      <!-- modal  -->
      <div class="modal" tabindex="-1" role="dialog" id="modal-confirm-order">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Order Detail</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <div class="container">
                <div class="form group">
                    <h1>Order Detail !!</h1>
                </div>
                <div class="form group">
                    <label>order ID (mã đơn hàng)</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-id-don-hang">
                </div>
                <div class="form group">
                    <label>Has Combo</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-combo">
                </div>
                <div class="form group">
                    <label>diameter pizza</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-diameter-pizza">
                </div>
                <div class="form group">
                    <label>sườn nướng (miếng)</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-suon">
                </div>
                <div class="form group">
                    <label>đồ uống</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-do-uong">
                </div>
                <div class="form group">
                    <label>số lượng đồ uống</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-so-luong-do-uong">
                </div>
                <div class="form group">
                    <label>Vooucher ID</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-voucher-id">
                </div>
                <div class="form group">
                    <label>loai Pizza</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-loai-pizza">
                </div>
                <div class="form group">
                    <label>Salad</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-salad">
                </div>
                <div class="form group">
                    <label>thành tiền</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-prices">
                </div>
                <div class="form group">
                    <label>Dícount</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-discount">
                </div>
                <div class="form group">
                    <label>họ và tên</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-ho-ten">
                </div>
                <div class="form group">
                    <label>email</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-email">
                </div>
                <div class="form group">
                    <label>Phone number</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-phone">
                </div>
                <div class="form group">
                    <label>Địa Chỉ</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-dia-chi">
                </div>
                <div class="form group">    
                    <label>lời nhắn</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-loi-nhan">
                </div>
                <div class="form group">    
                    <label>Trạng thái đơn hàng</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-status-cargo">
                </div>
                <div class="form group">    
                    <label>Ngày tạo đơn</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-ngay-tao">
                </div>
                <div class="form group">    
                    <label>ngày cập nhật</label>
                    <input type="text" class="form-control" placeholder="..." id="inp-ngay-update">
                </div>
            </div>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-cancel">Cancel</button>
              <button class="btn btn-dark" id="btn-confirm">Confirm</button>
            </div>
          </div>
        </div>
      </div>
      
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->


<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- datatable js-->
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
<script>
  "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCOLUMN_ID = 0;
    const gCOLUMN_KICH_CO_COMBO = 1;
    const gCOLUMN_lOAI_PIZZA = 2;
    const gCOLUMN_NUOC_UONG = 3;
    const gCOLUMN_THANH_TIEN = 4 ;
    const gCOLUMN_HO_VA_TEN = 5;
    const gCOLUMN_SO_DIEN_THOAI = 6;
    const gCOLUMN_TRANG_THAI = 7;
    const gCOLUMN_DETAIL = 8;
    // Định nghia columns name
    // declare a vaicable contain data from sever side
    const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    var gOrderArray = [];
    var gId = "";
    var gOrderCode = "";
    const gCOL_NAM_ARRAY = ["id","kichCo","loaiPizza","idLoaiNuocUong","thanhTien", "hoTen","soDienThoai","trangThai", "detail" ]
    // định nghĩa table  - chưa có data
    var gOrderTable = $("#user-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_ID]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_KICH_CO_COMBO]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_lOAI_PIZZA]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_NUOC_UONG]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_THANH_TIEN]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_HO_VA_TEN]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_SO_DIEN_THOAI]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_TRANG_THAI]},
          { "data" : gCOL_NAM_ARRAY[gCOLUMN_DETAIL]},
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_DETAIL,
          "defaultContent": `<i class="fa-solid fa-circle-info detail-icon"></i>`,
      }]
    });
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    $(".btn-filter-order").click(function(){
      onBtnFilterClick(this);
    });

    $(document).on("click" ,".detail-icon", function(){
      onBtnDetailIconClick(this);
    });

    $(document).on("click" ,"#btn-confirm", function(){
      onBtnConfirmClick(this);
    });

    $(document).on("click" ,"#btn-cancel", function(){
      onBtnCancelClick(this);
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // hàm chạy khi trang được load
    function onPageLoading() {
      // lấy data từ server
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          gOrderArray = responseObject;
          loadDataToTable(gOrderArray);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }

    // function on Btn filter Click 
    function onBtnFilterClick(paramFilter) {
      debugger
      // step 0 : declare a object contain data that is meed filter
      // step 1: get data 
      var vFilterObject = {
        loaiPizza: $("#inp-loai-pizza option:selected").text(),
        trangThai: $("#inp-order-status option:selected").text(),
      }
      // step 2: validate 
      var vCheck = validate(vFilterObject)
      // step 3: handle font-end
      if(vCheck){
        var vResult = filterData(vFilterObject);
        loadDataFilterToTable(vResult);
      }
    }
    
    // funciton handle event when click icon 
    function onBtnDetailIconClick(paramIcon) {
      // get Id or order Code
      gId = gOrderTable.row($(paramIcon).parents("tr")).data().id;
      gOrderCode = gOrderTable.row($(paramIcon).parents("tr")).data().orderCode;
      console.log(gId);
      console.log(gOrderCode);
      // show modal 
      $("#modal-confirm-order").modal("show");
      // load da form sever to modal 
      loadDataFromSeverToModal(gId,gOrderCode);
    }

    // funtion handle event on Btn confirm click on modal
    function onBtnConfirmClick(paramConfirm){
      // step 1: get Data
      var vUpdateStatus = {
        trangThai: "confirmed"
      }
      //step 2 validate data (no need )
      // step 3: call api to update data
      $.ajax({
        type: "PUT",
        data: JSON.stringify(vUpdateStatus),
        url: gBASE_URL+ "/" + gId,
        contentType: gUTF8_TEXT_APPLICATION_HEADER,
        dataType: "json",
        success: function(data){
          // anoucese to at screen 
          alert("ordering success")
          console.log("new objec is ")
          console.log(data);
          //add updated object to datatabe
          debugger
          updateObject(data)
          loadDataToTable(gOrderArray)
          // hida the modal 
          $("#modal-confirm-order").modal("hide");
        },
        error: function(jXhr) {
          console.log("faile error " + " " + jXhr.status)
        }
      })
    }
 
    // funtion handle event on Btn confirm click on modal
    function onBtnCancelClick(paramCancel){
      // step 1: get Data
      var vUpdateStatus = {
        trangThai: "cancel"
      }
      //step 2 validate data (no need )
      // step 3: call api to update data
      $.ajax({
        type: "PUT",
        data: JSON.stringify(vUpdateStatus),
        url: gBASE_URL+ "/" + gId,
        contentType: gUTF8_TEXT_APPLICATION_HEADER,
        dataType: "json",
        success: function(data){
          // annouces to at screen 
          alert("cancel success")
          console.log( "id is: " + gId)
          console.log("new objec is ")
          console.log(data);
          //add updated object to datatabe
          debugger
          updateObject(data)
          loadDataToTable(gOrderArray)
          // hida the modal 
          $("#modal-confirm-order").modal("hide");
        },
        error: function(jXhr) {
          console.log("faile error " + " " + jXhr.status)
        }
      })
    }
     
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    // load data to table
    function loadDataToTable(paramOrderArray) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramOrderArray);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }

    function loadDataFilterToTable(paramOrderArray) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramOrderArray);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }
  
    // validate funtion 
    function validate(paramFilterObject){
      if(paramFilterObject.loaiPizza == 0) {
        alert("you not select pizza type")
        return false;
      }
      if(paramFilterObject.trangThai == 0) {
        alert("you not select status")
        return false;
      }
      return true;
    }

    // filter function 
    function filterData(paramFilterObject){
      var vResult = [];
      debugger
      gOrderArray.forEach(object => {
        if(object.loaiPizza == paramFilterObject.loaiPizza &&
          object.trangThai == paramFilterObject.trangThai){
            vResult.push(object)
          }
      })
      console.log(vResult);
      return vResult;
    }

    // function show data on modal 
    function loadDataFromSeverToModal(){
      //step 1:  get all tag input
      var vInputElement = $("#modal-confirm-order input")
      console.log("test ")
      console.log(vInputElement.length)
      console.log(vInputElement[0])
      console.log(vInputElement)
      // step 2: validate (no need)
      // step 3:  call Api to get data from sever
      $.ajax({
        url: "http://203.171.20.210:8080/devcamp-pizza365/orders" + "/" + gOrderCode,
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          console.log(" get data success")
          console.log(responseObject)
            vInputElement[0].value = responseObject.orderCode
            vInputElement[1].value = responseObject.kichCo
            vInputElement[2].value = responseObject.suon
            vInputElement[3].value = responseObject.idLoaiNuocUong
            vInputElement[4].value = responseObject.soLuongNuoc
            vInputElement[5].value = responseObject.idVourcher
            vInputElement[6].value = responseObject.loaiPizza
            vInputElement[7].value = responseObject.salad
            vInputElement[8].value = responseObject.thanhTien
            vInputElement[9].value = responseObject.id
            vInputElement[10].value = responseObject.hoTen
            vInputElement[11].value = responseObject.email
            vInputElement[12].value = responseObject.soDienThoai
            vInputElement[13].value = responseObject.diaChi
            vInputElement[14].value = responseObject.loiNhan
            vInputElement[15].value = responseObject.trangThai
            vInputElement[16].value = responseObject.ngayTao
            vInputElement[17].value = responseObject.ngayCapNhat
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
    
    // function update status of order
    function updateObject(paramData) {
      var vOrderIndex = getIndexFromOerderID()
      gOrderArray.splice(vOrderIndex,1,paramData)
    }

    // funciton get order Index from id
    function getIndexFromOerderID(){
      var vFound = false;
      var vCount = 0
      var vIndex = -1
      while(!vFound, vCount < gOrderArray.length) {
        if(gOrderArray[vCount].id == gId) {
          vIndex = vCount;
          vFound = true;
        };
        vCount++;
      }
      return vIndex; 
    }



 });
</script>
</body>
</html>
